%define use_nss 1
%define ldap_support 1
%define static_ldap 0
%define krb5_support 1
%define nntp_support 1

%define soup_version 2.2.3
%define orbit2_version 2.14.9
%define libbonobo_version 2.20.0

%define eds_base_version 2.22
%define eds_api_version 1.2

%define use_gtk_doc 0
%define use_gnome_keyring 1
%define support_imap4_provider 0

%define camel_provider_dir %{_libdir}/evolution-data-server-%{eds_api_version}/camel-providers
%define eds_extensions_dir %{_libdir}/evolution-data-server-%{eds_api_version}/extensions

# Use stricter build settings than required by upstream.
%define strict_build_settings 1


Distribution:   CCux
Packager:	Karsten Brockmann <arcam@ccux-linux.de>

Name:		evolution-data-server
Version:	2.22.1
Release:	1
License:	GNU/LGPL 
URL: 		http://www.gnome.org/projects/evolution/
Group:		Graphical Desktop/GNOME/Base
Source0:	%{name}-%{version}.tar.bz2
# Remove gnome-common macros from configure.in.
Patch10: 	evolution-data-server-1.8.0-no-gnome-common.patch
# RH bug #202309
Patch11: 	evolution-data-server-1.7.91-maybe-fix-crash.patch
# RH bug #215702 / GNOME bug #487988
Patch12: 	evolution-data-server-1.8.0-fix-ldap-query.patch
# GNOME bug #373146
Patch13: 	evolution-data-server-1.10.1-camel-folder-summary-crash.patch
# RH bug #243296
Patch14: 	evolution-data-server-1.11.5-fix-64bit-acinclude.patch
Patch15: 	evolution-data-server-2.22.0-implicit-function-declaration.patch
BuildRoot:	%{_tmppath}/%{name}-buildroot
Summary:	Database for Evolution
Requires: 	GConf
Requires: 	ORBit2
Requires: 	db
Requires: 	gnome-vfs
Requires: 	libbonobo
Requires: 	libglade
Requires: 	libgnomeui
Requires: 	libsoup
### Build Dependencies ###
BuildRequires: 	GConf-devel
BuildRequires: 	ORBit2-devel
BuildRequires: 	bison
BuildRequires: 	db-devel
BuildRequires: 	flex
BuildRequires: 	gettext
BuildRequires: 	glib-devel
BuildRequires: 	gnome-vfs-devel
BuildRequires: 	gnutls-devel
BuildRequires: 	intltool
BuildRequires: 	libbonobo-devel
BuildRequires: 	libglade-devel
BuildRequires: 	libgnome-devel
BuildRequires: 	libgnomeui-devel
BuildRequires: 	libsoup-devel
BuildRequires: 	libtool

%if %{use_nss}
BuildRequires: 	nspr-devel
BuildRequires: 	nss-devel
%else
BuildRequires: 	openssl-devel
%endif

%if %{use_gtk_doc}
BuildRequires: 	gtk-doc
%endif

%if %{ldap_support}
%if %{static_ldap}
BuildRequires: openldap-evolution-devel
%else
BuildRequires: openldap-devel
%endif
%endif

%if %{krb5_support} 
BuildRequires: krb5-devel 
# tweak for krb5 1.2 vs 1.3
%define krb5dir /usr/kerberos
#define krb5dir `pwd`/krb5-fakeprefix
%endif

%description
The evolution-data-server package provides a unified backend for programs
that work with contacts, tasks, and calendar information.

It was originally developed for Evolution (hence the name), but is now used
by other packages.

%package devel
Summary: 	Development files for building against evolution-data-server
Group: 		Development/Libraries
Requires: 	%{name} = %{version}-%{release}
Requires: 	libbonobo-devel
Requires: 	libgnome-devel

%description devel
Development files needed for building things which link against 
evolution-data-server.

%post
ldconfig

%postun
ldconfig

%prep
%setup -q
%patch10 -p1 -b .no-gnome-common
%patch11 -p1 -b .maybe-fix-crash
%patch12 -p1 -b .fix-ldap-query
%patch13 -p1 -b .camel-folder-summary-crash
%patch14 -p1 -b .fix-64bit-acinclude
%patch15 -p1 -b .implicit-function-declaration

mkdir -p krb5-fakeprefix/include
mkdir -p krb5-fakeprefix/lib
mkdir -p krb5-fakeprefix/%{_lib}

%build
%if %{ldap_support}

%if %{static_ldap}
%define ldap_flags --with-openldap=%{_libdir}/evolution-openldap --with-static-ldap
%else
%define ldap_flags --with-openldap=yes
%endif

%else
%define ldap_flags --without-openldap
%endif

%if %{krb5_support}
%define krb5_flags --with-krb5=%{krb5dir}
%else
%define krb5_flags --without-krb5
%endif

%if %{nntp_support}
%define nntp_flags --enable-nntp=yes
%else
%define nntp_flags --enable-nntp=no
%endif

%if %{use_nss}
%define ssl_flags --enable-nss=yes --enable-smime=yes
%else
%define ssl_flags --enable-openssl=yes
%endif

%if %{use_nss}
if ! pkg-config --exists nss; then 
  echo "Unable to find suitable version of nss to use!"
  exit 1
fi
%endif

%if %{use_gnome_keyring}
%define keyring_flags --enable-gnome-keyring
%else
%define keyring flags --disable-gnome-keyring
%endif

%if %{support_imap4_provider}
%define imap4_flags --enable-imap4=yes
%else
%define imap4_flags --enable-imap4=no
%endif

export CPPFLAGS="-I%{_includedir}/et"
export CFLAGS="$RPM_OPT_FLAGS -DLDAP_DEPRECATED -fPIC -I%{_includedir}/et"
%if ! %{use_nss}
if pkg-config openssl ; then
	CFLAGS="$CFLAGS `pkg-config --cflags openssl`"
	LDFLAGS="$LDFLAGS `pkg-config --libs-only-L openssl`"
fi
%endif

%if %{use_gtk_doc}
%define gtkdoc_flags --enable-gtk-doc
%else
%define gtkdoc_flags --enable-gtk-doc=no
%endif

# Add stricter build settings here as the source code gets cleaned up.
# We want to make sure things like compiler warnings and avoiding deprecated
# functions in the GNOME/GTK+ libraries stay fixed.
#
# Please file a bug report at bugzilla.gnome.org if these settings break
# compilation, and encourage the upstream developers to use them.

%if %{strict_build_settings}
CFLAGS="$CFLAGS \
	-DG_DISABLE_DEPRECATED=1 \
        -DPANGO_DISABLE_DEPRECATED=1 \
	-DGDK_PIXBUF_DISABLE_DEPRECATED=1 \
	-DGDK_DISABLE_DEPRECATED=1 \
	-Wdeclaration-after-statement"
#	-Werror-implicit-function-declaration"
%endif

# Regenerate configure to pick up configure.in and acinclude.m4 changes.
aclocal
autoheader
automake
libtoolize
intltoolize --force
autoconf

# See Ross Burton's blog entry for why we want --with-libdb.
# http://www.burtonini.com/blog//computers/eds-libdb-2006-07-18-10-40

%configure \
	%gtkdoc_flags \
	--with-libdb=/usr \
	--enable-file-locking=fcntl \
	--enable-dot-locking=no \
	--libexecdir=%{_libdir}/evolution-data-server-%{eds_api_version} \
	%ldap_flags %krb5_flags %nntp_flags %ssl_flags %imap4_flags \
	%keyring_flags
export tagname=CC
make %{?_smp_mflags} LIBTOOL=/usr/bin/libtool

%install
rm -rf $RPM_BUILD_ROOT
export tagname=CC
make DESTDIR=$RPM_BUILD_ROOT LIBTOOL=/usr/bin/libtool install

# give the libraries some executable bits 
find $RPM_BUILD_ROOT -name '*.so.*' -exec chmod +x {} \;

%find_lang %{name}-%{eds_base_version}

%files -f %{name}-%{eds_base_version}.lang
%defattr(-,root,root,-)
%doc README COPYING ChangeLog NEWS AUTHORS
%{_libdir}/bonobo/servers/GNOME_Evolution_DataServer_%{eds_api_version}.server
%{_libdir}/libcamel-%{eds_api_version}.so.*
%{_libdir}/libcamel-provider-%{eds_api_version}.so.*
%{_libdir}/libebook-%{eds_api_version}.so.*
%{_libdir}/libecal-%{eds_api_version}.so.*
%{_libdir}/libedata-book-%{eds_api_version}.so.*
%{_libdir}/libedata-cal-%{eds_api_version}.so.*
%{_libdir}/libedataserver-%{eds_api_version}.so.*
%{_libdir}/libedataserverui-%{eds_api_version}.so.*
%{_libdir}/libegroupwise-%{eds_api_version}.so.*
%{_libdir}/libexchange-storage-%{eds_api_version}.so.*
%{_libdir}/libgdata-%{eds_api_version}.so.*
%{_libdir}/libgdata-google-%{eds_api_version}.so.*

%{_libdir}/evolution-data-server-1.2/evolution-data-server-%{eds_base_version}
%{_libdir}/evolution-data-server-1.2/camel-index-control-%{eds_api_version}
%{_libdir}/evolution-data-server-1.2/camel-lock-helper-%{eds_api_version}
%{_datadir}/evolution-data-server-%{eds_base_version}
%{_datadir}/idl/evolution-data-server-%{eds_api_version}
%{_datadir}/pixmaps/evolution-data-server
%dir %{_libdir}/evolution-data-server-%{eds_api_version}
%dir %{camel_provider_dir}
%dir %{eds_extensions_dir}

# Camel providers:
%{camel_provider_dir}/libcamelgroupwise.so
%{camel_provider_dir}/libcamelgroupwise.urls

%{camel_provider_dir}/libcamelhula.so
%{camel_provider_dir}/libcamelhula.urls

%{camel_provider_dir}/libcamelimap.so
%{camel_provider_dir}/libcamelimap.urls

%if %{support_imap4_provider}
%{camel_provider_dir}/libcamelimap4.so
%{camel_provider_dir}/libcamelimap4.urls
%endif

%{camel_provider_dir}/libcamellocal.so
%{camel_provider_dir}/libcamellocal.urls

%{camel_provider_dir}/libcamelnntp.so
%{camel_provider_dir}/libcamelnntp.urls

%{camel_provider_dir}/libcamelpop3.so
%{camel_provider_dir}/libcamelpop3.urls

%{camel_provider_dir}/libcamelsendmail.so
%{camel_provider_dir}/libcamelsendmail.urls

%{camel_provider_dir}/libcamelsmtp.so
%{camel_provider_dir}/libcamelsmtp.urls

# e-d-s extensions:
%{eds_extensions_dir}/libebookbackendfile.so
%{eds_extensions_dir}/libebookbackendgroupwise.so
%{eds_extensions_dir}/libebookbackendldap.so
%{eds_extensions_dir}/libebookbackendvcf.so
%{eds_extensions_dir}/libecalbackendcontacts.so
%{eds_extensions_dir}/libecalbackendfile.so
%{eds_extensions_dir}/libecalbackendgroupwise.so
%{eds_extensions_dir}/libecalbackendhttp.so
%{eds_extensions_dir}/libecalbackendweather.so
%{eds_extensions_dir}/libecalbackendcaldav.so
%{eds_extensions_dir}/libecalbackendgoogle.so

%files devel
%defattr(-,root,root,-)
%{_libdir}/*.la
%{_libdir}/*.a
%{_libdir}/evolution-data-server-%{eds_api_version}/camel-providers/*.a
%{_libdir}/evolution-data-server-%{eds_api_version}/extensions/*.a
%{_libdir}/evolution-data-server-%{eds_api_version}/camel-providers/*.la
%{_libdir}/evolution-data-server-%{eds_api_version}/extensions/*.la
%{_includedir}/evolution-data-server-%{eds_base_version}
%{_datadir}/gtk-doc/html/*
%{_libdir}/libcamel-%{eds_api_version}.so
%{_libdir}/libcamel-provider-%{eds_api_version}.so
%{_libdir}/libebook-%{eds_api_version}.so
%{_libdir}/libecal-%{eds_api_version}.so
%{_libdir}/libedata-book-%{eds_api_version}.so
%{_libdir}/libedata-cal-%{eds_api_version}.so
%{_libdir}/libedataserver-%{eds_api_version}.so
%{_libdir}/libedataserverui-%{eds_api_version}.so
%{_libdir}/libegroupwise-%{eds_api_version}.so
%{_libdir}/libexchange-storage-%{eds_api_version}.so
%{_libdir}/libgdata-%{eds_api_version}.so
%{_libdir}/libgdata-google-%{eds_api_version}.so
%{_libdir}/pkgconfig/camel-%{eds_api_version}.pc
%{_libdir}/pkgconfig/camel-provider-%{eds_api_version}.pc
%{_libdir}/pkgconfig/evolution-data-server-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libebook-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libecal-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libedata-book-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libedata-cal-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libedataserver-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libedataserverui-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libegroupwise-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libexchange-storage-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libgdata-%{eds_api_version}.pc
%{_libdir}/pkgconfig/libgdata-google-%{eds_api_version}.pc

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Apr 09 2008 Christian Metzen <metzench@ccux-linux.de> 2.22.1-1
- Version update
* Wed Mar 12 2008 Christian Metzen <metzench@ccux-linux.de> 2.22.0-1
- Version update
* Mon Jan 07 2008 Christian Metzen <metzench@ccux-linux.de> 1.12.3-1
- Version update
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1.12.2-1
- Version update
* Mon Oct 15 2007 Christian Metzen <metzench@ccux-linux.de> 1.12.1-1
- Version update
* Fri Sep 28 2007 Christian Metzen <metzench@ccux-linux.de> 1.12.0-1
- Version update
* Tue Mar 19 2007 Christian Metzen <metzench@ccux-linux.de> 1.10.0-1
- Version update
* Fri Dec 08 2006 Christian Metzen <metzench@ccux-linux.de> 1.9.3-1
- Version update
* Mon Nov 20 2006 Christian Metzen <metzench@ccux-linux.de> 1.9.2-1
- Version update
* Thu Nov 09 2006 Christian Metzen <metzench@ccux-linux.de> 1.9.1-3
- clean buildchain
* Tue Nov 07 2006 Christian Metzen <metzench@ccux-linux.de> 1.9.1-2
- rebuild, moved libexec
* Mon Nov 06 2006 Christian Metzen <metzench@ccux-linux.de> 1.9.1-1
- Version update, moved prefix
* Wed May 31 2006 Christian Wasem <wasem@ccux-linux.de> 1.5.91-2
- rebuild against newer libtasn
* Wed Feb 01 2006 Karsten Brockmann <arcam@ccux-linux.de> 1.5.91-1
- Initial Release
